
% M maximum observations number,ni() is 1*n vector containing the lengths
% of obsevation or each individual with n individuals;Ni() is the same vector 
%but after data imputation .D:MCMC iteration number,
%a is the number of the discrete Markov states,q is the transition
% matrix for the n individuals and M is the maximum observations number for each
% individual before data imputation and Mx is the the maximum observation for each
% individual after imputation
%s contains the hidden states and the times of switching for the states.
% x is the observation matrix before imputation. 
% xxim is the observation matrix after imputation. 
%sdd is the matrix for the hidden state after imputation.
% First we generate a process from some true values, then we ran our MCMC 
% for sufficiently a large number of iteration D  to obtain an output from each
% parrameter.    
rng('shuffle');
M=10;Mx=120;n=30;D=1000;ni=zeros(n,1);a=3;s=zeros(2,n,M);x=zeros(n,M);
% Generating ni between 7 and M
for i=1:n
    ni(i)=randi([7,M],1,1);       
end
%Parameter of the diffusion process with initialization
%alp0 is the MCMC vector for the alpha0.
%alp1 is the MCMC vector for the alpha1.
%alp2 is the MCMC vector for the alpha2.
%alp3 is the MCMC vector for the alpha3.
%Parameter of the diffusion process with initialization
alp0=zeros(a,D);alp1=zeros(a,D);alp2=zeros(a,D);alp3=zeros(a,D);
%ph0 is the generation vector for alpha0.
%ph1 is the generation vector for alpha1.
%ph2 is the generation vector for alpha2.
%ph3 is the generation vector for alpha3
ph0=[0.3 ;0.6 ;0.9];ph1=[0.02;0.04;0.06];ph2=[-0.08;-0.06;-0.04];
ph3=[0.01;0.05;0.09];
alp0(:,1)=[0.29 ;0.61 ;0.87];alp1(:,1)=[0.018;0.043;0.056];
alp2(:,1)=[-0.084;-0.055;-0.039];
alp3(:,1)=[0.009;0.052;0.1]; 
b0=[0.3 0.02 -0.08 0.01;0.6 0.04 -0.06 0.05;0.9 0.06 -0.04 0.09];
B0=zeros(a,4,4);
b01=squeeze(b0(1,:));
b02=squeeze(b0(2,:));
b03=squeeze(b0(3,:));
%Hyper-parameters for the prior in the case for switching regression.
B0(1,:,:)=[0.01 0 0 0;0 0.01 0 0;0 0 0.01 0;0 0 0 0.01];
B01=squeeze(B0(1,:,:));
B0(2,:,:)=[0.02 0 0 0;0 0.02 0 0;0 0 0.02 0;0 0 0 0.02];
B02=squeeze(B0(2,:,:));
B0(3,:,:)=[0.03 0 0 0;0 0.03 0 0;0 0 0.03 0;0 0 0 0.03];
B03=squeeze(B0(3,:,:));
% eta matrix with initialization
eta=zeros(a,D);eta0=[0.3;0.4;0.5];
eta(:,1)=[0.32;0.37;0.49];
%sigma matrix with initialization
sig=zeros(1,D);sig0=0.02;sig(1,1)=0.017;
% An initial distribution for the hidden states
r=zeros(a,D);r0=[0.3 0.3 0.4];r(:,1)=[0.31;0.31;0.36];
%alphazeros  for the prior of the initial distribution.
alphazeros=[1;1;1];
%Parameters of Gompertz function in the transition rate matrix q0
% The lamdas lmda0 and the gammas gma0, parmeter used to generate the first
% q0
lmda0=[0 0.2 1;0.3 0 2;0.4 7 0];gma0=[0 0.2 0.04;0.3 0 0.06;0.4 0.08 0];
lmda(:,:,1)=[0 0.18 1.02;0.29 0 1.9;0.37 6.77 0];
gma(:,:,1)=[0 0.22 0.043;0.27 0 0.055;0.39 0.078 0];
%the q0 saves for all the n individuals and the the times before imputation
q0=zeros(a,a,n,M);
%Generation of the diffusion observations and the Markov switching
%states
for i=1:n
    %choose the first regime switching state
    s(1,i,1)=samplefromp(r0,1);k= s(1,i,1);s(2,i,1)=0;
    %Initialize the first observation in the diffusion process 
    x(i,1)=normrnd((ph0(k)),sig0(1));    
    %compute the transition matrix for the initial time ti1
    qadjust=zeros(a,a);
    for k=1:a            
      for l=1:a
        if l~=k  
         qadjust(k,l)=lmda0(k,l)*exp(-gma0(k,l)*x(i,1));
         qadjust=normalizeq(qadjust,k);
        end 
     end
    end
    q0(:,:,i,1)=qadjust(:,:);rr=s(1,i,1);
     %Simulation of the next time ti2 and save it in s(2,i,2)
    er=1/(-q0(rr,rr,i,1));
    s(2,i,2)=exprnd(er);
    %Computation of the hidden states for the time tij
   for j=2:ni(i)
       qminus=zeros(2,a-1);l=1;
       rr=s(1,i,j-1);
     for k=1:a
        if (k~=rr)
           qminus(1,l)=q0(rr,k,i,j-1);qminus(2,l)=k;l=l+1; 
        end
     end    
     mnqminus=zeros(1,a-1);mnqminus(1,:)=qminus(1,:)/(-q0(rr,rr,i,j-1));
     mn=mnrnd(1,mnqminus(1,:));f=find(mn,1,'first');s(1,i,j)=qminus(2,f);
     k=s(1,i,j-1);
     %Computation of the observation xij
     x(i,j)=x(i,j-1)+(ph0(k,1)+ph1(k,1)*x(i,j-1)+ph2(k,1)*(x(i,j-1))^2+...
         ph3(k,1)/x(i,j-1))...
     *(s(2,i,j)-s(2,i,j-1))+sqrt(sig0(1,1))*((x(i,j-1))^(eta0(k,1)))*...
     (sqrt(s(2,i,j)-s(2,i,j-1)));
     %Simulation of the transition rate matrix for the time tij
     qadjust=zeros(a,a);
      for k=1:a            
       for l=1:a
         if l~=k  
          qadjust(k,l)=lmda0(k,l)*exp(-gma0(k,l)*x(i,j-1));
          qadjust=normalizeq(qadjust,k);
         end 
       end
     end
     q0(:,:,i,j)=qadjust(:,:);rr=s(1,i,j);
     %Computation of the next time tij+1
      if j<ni(i)
         er=1/(-q0(rr,rr,i,j));
         s(2,i,j+1)=exprnd(er)+s(2,i,j);
      end
   end  
end
%After the generation, we start our MCMC algorithm
%Data imputation for d=1 and initialization of the switching states
%xim, st and td are respectively the imputed data,the hidden states and the 
%times of imputations
%N1(i)and N(i) are the number of observations including the imputed data
%for individual i for both the previous MCMC iteration d and the new MCMC
%iteration d.
%td1 and td are the times of imputation for both the previous MCMC iteration 
%and the new MCMC iteration.
%xs1 and xs save the positions of the original observations after
% imputation .  
N1=zeros(n,1);td1=zeros(n,Mx);xs1=zeros(n,M);
N=zeros(n,1);td=zeros(n,Mx);xs=zeros(n,M);
%An intermediate matrix to save the hidden states for all the tij.
st=zeros(n,Mx);
%The new transition rate matrix q for all the times tij including the new
%imputed times
q=zeros(a,a,n,Mx);
%Creation of the times of imputation using an exponential random
% s2id saves all diagonal elements for q0 for all the time 
s2id=zeros(a,n,M);
for i=1:n
    for j=1:ni(i)
        for k=1:a
           s2id(k,i,j)=-q0(k,k,i,j);    
        end    
    end  
end
%The maximum of the diagonal elements
s2imax=(max(s2id(:))+0.05);

for i=1:n
    xs1(i,1)=1;
    N1(i)=1;
    td1(i,1)=s(2,i,1);
   for j=2:(ni(i))
       xx=exprnd(1/s2imax);
       tdd=s(2,i,j-1)+xx;
       while tdd<s(2,i,j)
       N1(i)=N1(i)+1;    
       td1(i,N1(i))=tdd;        
       xx=exprnd(1/s2imax);
       tdd=tdd+xx;
       end
      N1(i)=N1(i)+1;
      td1(i,N1(i))=s(2,i,j);
      xs1(i,j)=N1(i);
   end   
end
%Creation of the imputed observations and the corresponding hidden states 
% for MCMC iteration d=1.
%The matrix of the imputed data xim
xim=zeros(n,Mx);
for i=1:n
   k=1;
   for j=1:N1(i) 
     if j==xs1(i,k) 
        xim(i,j)=x(i,k);st(i,j)=s(1,i,k);q(:,:,i,j)=q0(:,:,i,k);k=k+1;
      else 
        qminus=zeros(2,a-1);ss =1;kk=st(i,j-1);
        for rr=1:a
            if (rr~=kk)
               qminus(1,ss)=q(kk,rr,i,j-1);qminus(2,ss)=rr;ss=ss+1; 
            end
        end
        mnqminus=zeros(1,a-1);mnqminus(1,:)=qminus(1,:)/(-q(kk,kk,i,j-1));
        mn=mnrnd(1,mnqminus(1,:));f=find(mn,1,'first');st(i,j)=qminus(2,f);
        kk=st(i,j-1);
        %Compute the imputed data 
        xim(i,j)=xim(i,j-1)+(ph0(kk,1)+ph1(kk,1)*xim(i,j-1)+ph2(kk,1)*(xim(i,j-1))^2+ph3(kk,1)/xim(i,j-1))...
        *(td1(i,j)-td1(i,j-1))+sqrt(sig0(1,1))*((xim(i,j-1))^(eta0(kk,1)))*(sqrt(td1(i,j)-td1(i,j-1)));
       qadjust=zeros(a,a);
          for rr=1:a            
               for ss=1:a
                   if ss~=rr  
                      qadjust(rr,ss)=lmda(rr,ss,1)*exp(-gma(rr,ss,1)*xim(i,j-1));
                      qadjust=normalizeq(qadjust,rr);
                   end 
               end
          end
          %Update the transition rate matrix  
         q(:,:,i,j)=qadjust(:,:);
     end    
   end 
end
%xxd saves the observations including the imputed observations for all MCMC
%iterations.
%sdd saves the hidden states for all MCMC iterations including the stacked
% hidden states
%qold the transition rate matrix is saved for use in the next MCMC
%iteration
xxd=zeros(n,Mx,D);sdd=zeros(n,Mx,D);qold=zeros(a,a,n,Mx);
for i=1:n
xxd(i,:,1)=xim(i,:);
sdd(i,:,1)=st(i,:);
  for j=1:N1(i)
    qold(:,:,i,j)=q(:,:,i,j);
  end
end
XIMP=zeros(n,Mx);qim=zeros(a,a,n,Mx);
%The main algorithm
for i=1:n
N(i)=N1(i);td(i,:)=td1(i,:);xs(i,:)=xs1(i,:);
end
sim=zeros(n,Mx);
for d=1:D
%Metropolis hasting algorithm for the imputed data
%XIMP will save the old observations including the imputed ones
XIMP=squeeze(xxd(:,:,d));
%First create the proposal times of imputation
for i=1:n
    xs1(i,1)=1;
    N1(i)=1;
    td1(i,1)=s(2,i,1);
   for j=2:(ni(i))
       xx=exprnd(1/s2imax);
       tdd=s(2,i,j-1)+xx;
       while tdd<s(2,i,j)
       N1(i)=N1(i)+1;    
       td1(i,N1(i))=tdd;        
       xx=exprnd(1/s2imax);
       tdd=tdd+xx;
       end
      N1(i)=N1(i)+1;
      td1(i,N1(i))=s(2,i,j);
      xs1(i,j)=N1(i);
   end   
end
%Create the proposed imputed data xim
% this imputation gives rise to the computation of intermediate transition
% rate matrix qim and the simulation of intermediate hidden states sim.



for i=1:n
    Nom1=1;Den1=1; Nom2=1;Den2=1;l=1;qold(:,:,i,:)=q(:,:,i,:);
    while l<(ni(i))
     km1=xs1(i,l);km2=xs1(i,l+1);km11=xs(i,l);km21=xs(i,l+1);
     xim(i,km1)=x(i,l);xim(i,km2)=x(i,l+1);
     sim(i,km1)=sdd(i,km11,d);sim(i,km2)=sdd(i,km21,d);
     qim(:,:,i,km1)=qold(:,:,i,km11); qim(:,:,i,km2)=qold(:,:,i,km21);
    if   km2-km1<=1
         l=l+1;
    else    
       for j=km1+1:km2-1
           kk=sim(i,j-1);
           %Compute the imputed data using modified Browanian proposal
           xim(i,j)=normrnd((xim(i,j-1)+(xim(i,km2)-xim(i,j-1))*((td1(i,j)-td1(i,j-1))/...
           (td1(i,km2)-td1(i,j-1)))),((sig(1,d))*((xim(i,j-1))^(2*eta(kk,d)))*...
          (td1(i,j)-td1(i,j-1))*(td1(i,km2)-td1(i,j))/(td1(i,km2)-td1(i,j-1))));
          qadjust=zeros(a,a);
          for rr=1:a            
               for ss=1:a
                   if ss~=rr  
                      qadjust(rr,ss)=lmda(rr,ss,1)*exp(-gma(rr,ss,1)*xim(i,j-1));
                      qadjust=normalizeq(qadjust,rr);
                   end 
               end
          end 
          %Check whether there is a switch 
         qim(:,:,i,j)=qadjust(:,:);      
         ratioswitch=min(1,((-qim(kk,kk,i,j-1))/s2imax));
         %If no switch keep the previous hidden state
         u=rand(); 
         if ratioswitch<=u
             sim(i,j)=sim(i,j-1);
         %Else draw the hidden state sim(i,j)    
         else
           qminus=zeros(2,a-1);ss =1;kk=sim(i,j-1);         
           for rr=1:a
             if (rr~=kk)
               qminus(1,ss)=qim(kk,rr,i,j-1);qminus(2,ss)=rr;ss=ss+1; 
             end
           end
           mnqminus=zeros(1,a-1);
           mnqminus(1,:)=qminus(1,:)/(-qim(kk,kk,i,j-1));
           mn=mnrnd(1,mnqminus(1,:));f=find(mn,1,'first');
           sim(i,j)=qminus(2,f);                    
         end  
         kk=sim(i,j-1);
         Den1=Den1*normpdf(xim(i,j),xim(i,j-1)+(xim(i,km2)-xim(i,j-1))*...
             (td1(i,j)-td1(i,j-1))/...
         (td1(i,km2)-td1(i,j-1)),((sig(1,d))*((xim(i,j-1))^(2*eta(kk,d)))*...
         (td1(i,j)-td1(i,j-1))*(td1(i,km2)-td1(i,j))/(td1(i,km2)-td1(i,j-1))));    
       end 
    l=l+1;   
    end
    end
 
    xim(i,(N1(i)))=x(i,(ni(i)));
    qim(:,:,i,N1(i))=qold(:,:,i,N(i));      
    
     for  j=2:(N1(i))
          k=sim(i,j-1);
          Nom2=Nom2*normpdf(xim(i,j),xim(i,j-1)+(alp0(k,d)+alp1(k,d)*xim(i,j-1)...
              +alp2(k,d)*((xim(i,j-1))^2)+(alp3(k,d)/xim(i,j-1)))...
          *(td1(i,j)-td1(i,j-1)),sig(1,d)*((xim(i,j-1)^(2*eta(k,d))))*...
          (td1(i,j)-td1(i,j-1)));      
     end
    l=1; 
    while l<(ni(i))
          km11=xs(i,l);km21=xs(i,l+1);
         if   km21-km11<=1
              l=l+1;
         else    
           for j=km11+1:km21-1
             k=sdd(i,j-1,d);
             Nom1=Nom1*normpdf(XIMP(i,j),XIMP(i,j-1)+(XIMP(i,km21)-XIMP(i,j-1))...
                 *(td(i,j)-td(i,j-1))/...
             (td(i,km21)-td(i,j-1)),((sig(1,d))*((XIMP(i,j-1))^(2*eta(k,d)))*...
             (td(i,j)-td(i,j-1))*(td(i,km21)-td(i,j))/(td(i,km21)-td(i,j-1))));
           end 
         l=l+1;  
         end 
    end 
  Nomvector1(i,d)=Nom1;   
   for  j=2:(N(i))
         k=sdd(i,j-1,d);         
         Den2=Den2*normpdf(XIMP(i,j),XIMP(i,j-1)+(alp0(k,d)+alp1(k,d)*...
             XIMP(i,j-1)...
             +(alp2(k,d)*(XIMP(i,j-1))^2)+(alp3(k,d)/XIMP(i,j-1)))...
          *(td(i,j)-td(i,j-1)),sig(1,d)*((XIMP(i,j-1)^(2*eta(k,d))))...
          *(td(i,j)-td(i,j-1)));       
   end
    %Finally update the xxd,q, and sim after deciding based on the MHA
     mh=min(1,Nom1*Nom2/Den1*Den2);u=rand();
     if mh>u 
         N(i)=N1(i);td(i,:)=td1(i,:);q(:,:,i,:)=qim(:,:,i,:);xs(i,:)=xs1(i,:);
         xxd(i,:,d+1)=xim(i,:);
     else
         xxd(i,:,d+1)=XIMP(i,:);N1(i)=N(i);td1(i,:)=td(i,:);
         q(:,:,i,:)=qold(:,:,i,:);sim(i,:)=squeeze(sdd(i,:,d));         
     end   
end  
     
        
% Forward backward simulation of the hidden states
%fsmatrix saves forward probabilities bsmatrix saves backward probabilities
for i=1:n
    fsmatrix=zeros(a,Mx);bsmatrix=zeros(a,Mx);fsmatrixminusone=zeros(a,Mx);
    %initialisation first state
    sumfzero=0;
    for k=1:a
        sumfzero=sumfzero+obsdensityfzero(k,i,xxd,alp0,sig,d)*r(k,d);        
    end
    for k=1:a
        fsmatrix(k,1)=obsdensityfzero(k,i,xxd,alp0,sig,d)*r(k,d)/sumfzero;
    end
    for j=2:N1(i)
        %calculate the transition probability matrix for each time tij
        p=squeeze(q(:,:,i,j))*(td1(i,j)-td1(i,j-1));
        p=expm(p);
        %first calculate forward matrix for every k and the time tij-1
        for k=1:a
            fsmatrixminusone(k,j)=0;
            for l=1:a
                fsmatrixminusone(k,j)=fsmatrixminusone(k,j)+...
                p(l,k)*fsmatrix(l,j-1);
            end
        end
        
        %now we calculate forward matrix for every k at the time tij
        sumfs=0;k=sim(i,j-1);
         for l=1:a
             sumfs=sumfs+fsmatrixminusone(l,j)*...
             observationdensityf(k,i,j,xxd,alp0,alp1,alp2,alp3,eta,sig,td1,d);             
         end
         for l=1:a        
             fsmatrix(l,j)=fsmatrixminusone(l,j)*...
             observationdensityf(k,i,j,xxd,alp0,alp1,alp2,alp3,eta,sig,td1,d)...
             /sumfs;
         end
    end
  

%Backward calculation
% we deduce first the simulation of sdd_N1i(i) from forward calculation
mn=mnrnd(1,fsmatrix(:,N1(i)));
sdd(i,N1(i),d+1)=find(mn,1,'first');
%x(i,ni(i),d+1)=randsample(a,1,true,fsmatrix(:,ni(i)));
%we  simulate  sdd_ij from forward calculation
for j=N1(i)-1:-1:1
    ind=sdd(i,j+1,d+1);p=squeeze(q(:,:,i,j+1))*(td1(i,j+1)-td1(i,j));
    p=expm(p);
    sumbs=0;
    for l=1:a
        sumbs=sumbs+fsmatrix(l,j)*p(l,ind);
    end
    for k=1:a        
        bsmatrix(k,j)=fsmatrix(k,j)*p(k,ind)/sumbs;
    end
   mn=mnrnd(1,bsmatrix(:,j));
   sdd(i,j,d+1)=find(mn,1,'first');   
 end
end

%number of intial states nis
nis=zeros(1,a);
for i=1:n
    for k=1:a
        if (sdd(i,1,d+1)==k)
            nis(1,k)=nis(1,k)+1;
        end
    end
end  
% Initial distribution posterior using a dirchlet posterior
r(:,d+1)=drchrnd1(alphazeros(1,:)+nis(1,:));

%Simulation of the parameters of the Gompertz model in the transition rate
%matrix
%1)simulation of lamda's
lamdaprime=squeeze(lmda(:,:,d));qn=zeros(a,a);lamdaproposal=zeros(a,a);
aq=zeros(a,a);bq=zeros(a,1);nm=1;dn=1;qproposal=q;qold=q;priornew=1;
 priorold=1;
 for k=1:a
    for l=1:a        
        if l~=k
           loglamda=normrnd(log(mean2(lmda(k,l,1:d))),0.02);
           lamdaproposal(k,l)=exp(loglamda); 
           priorold=priorold*gampdf(lmda(k,l,d),0.01,0.01);
           priornew=priornew*gampdf(lamdaproposal(k,l),0.01,0.01);
        end
    end
 end
for k=1:a
    for l=1:a        
        if l~=k
           for i=1:n
               qproposal(k,l,i,1)=lamdaproposal(k,l)*exp(-gma(k,l,d)*...
                   xxd(i,1,d+1));   
               qn=squeeze(qproposal(:,:,i,1));qn=normalizeq(qn,k);
               qproposal(:,:,i,1)=qn(:,:);                     
               for j=2:N1(i)
                   qproposal(k,l,i,j)=lamdaproposal(k,l)*exp(-gma(k,l,d)*...
                       xxd(i,j-1,d+1));   
                   qn=squeeze(qproposal(:,:,i,j));qn=normalizeq(qn,k);
                   qproposal(:,:,i,j)=qn(:,:);                        
               end
           end
        end
    end
end 

for i=1:n                   
    for j=2:N1(i)                                           
        pnew=squeeze(qproposal(:,:,i,j))*(td1(i,j)-td1(i,j-1));
        pnew=expm(pnew); 
        pex=squeeze(qold(:,:,i,j))*(td1(i,j)-td1(i,j-1));pex=expm(pex);
        nm=nm*pnew(sdd(i,j-1,d+1),sdd(i,j,d+1));
        dn=dn*pex(sdd(i,j-1,d+1),sdd(i,j,d+1));
    end
end           
% The Metropolis Hastings algorithm for the lamdas (prior*likelihood)
prnew=priornew*nm;
prold=priorold*dn;
mh=min(1,prnew/prold);u=rand();
if u<mh
    lmda(:,:,d+1)=lamdaproposal(:,:);q=qproposal; 
else
   lmda(:,:,d+1)=lmda(:,:,d);
end       


%Simulation of the parameters of the gompertz model in the transition rate
%matrix
%2)simulation of gamma's
gammaprime=squeeze(gma(:,:,d));gammaproposal=zeros(a,a);
priorold=1;priornew=1;
for k=1:a
    for l=1:a        
        if l~=k
           loggamma=normrnd(log(mean2(gma(k,l,1:d))),0.04);
           gammaproposal(k,l)=exp(loggamma); 
           priornew=priornew*gampdf(gammaproposal(k,l),0.01,0.01);
           priorold=priorold*gampdf(gma(k,l,d),0.01,0.01);
        end
    end
end
nm=1;dn=1;qproposal=q;qold=q;
for k=1:a
    for l=1:a        
        if l~=k            
           for i=1:n
               qproposal(k,l,i,1)=lmda(k,l,d+1)*exp(gammaproposal(k,l)*...
                   xxd(i,1,d+1));   
               qn=squeeze(qproposal(:,:,i,1));qn=normalizeq(qn,k);
               qproposal(:,:,i,1)=qn(:,:);                     
               for j=2:N1(i)
                   qproposal(k,l,i,j)=lmda(k,l,d+1)*exp(gammaproposal(k,l)*...
                       xxd(i,j-1,d+1));   
                   qn=squeeze(qproposal(:,:,i,j));qn=normalizeq(qn,k);
                   qproposal(:,:,i,j)=qn(:,:);                         
               end
           end
        end
    end 
end
for i=1:n                                   
    for j=2:N1(i)
         pnew=squeeze(qproposal(:,:,i,j))*(td1(i,j)-td1(i,j-1));pnew=expm(pnew); 
         pex=squeeze(qold(:,:,i,j))*(td1(i,j)-td1(i,j-1));pex=expm(pex);
         nm=nm*pnew(sdd(i,j-1,d+1),sdd(i,j,d+1));dn=dn*pex(sdd(i,j-1,d+1),sdd(i,j,d+1));                
    end   
end
 % The Metropolis Hastings algorithm ratio for the gammas (prior*likelihood) 
prnew=priornew*nm;
prold=priorold*dn;
mh=min(1,prnew/prold);u=rand();
if u<mh
    gma(:,:,d+1)=gammaproposal(:,:);q=qproposal;
else  
    gma(:,:,d+1)=gma(:,:,d);               
end  
%Simulation of alpha0,alpha1,alph2,alpha3,sigma 
%using a switching regression appraoch:
B1=zeros(4,4);Y=zeros(a,2000);y=zeros(a,4,2000);kj=zeros(4,4);
A=0.22;B=0.01; 
c1=zeros(a,1);C1=zeros(a,1);bta=zeros(a,4);mx=zeros(a,1);
% bta is the matrix alpha0,alpha1,alph2,alpha3 that depends on three hidden
% states.
for k=1:a
 bta(k,:)=[alp0(k,d),alp1(k,d),alp2(k,d),alp3(k,d)];   
end   
for i=1:n
    for j=2:N1(i)
        k=sdd(i,j-1,d+1);mx(k)=mx(k)+1;
        Y(k,mx(k))=(xxd(i,j,d+1)-xxd(i,j-1,d+1))/((xxd(i,j-1,d+1)^(eta(k,d)))*...
            sqrt((td1(i,j)-td1(i,j-1))));
        sss=[1,xxd(i,j-1,d+1),(xxd(i,j-1,d+1))^2,1/xxd(i,j-1,d+1)];
        sc=sqrt((td1(i,j)-td1(i,j-1)))/((xxd(i,j-1,d+1)^(eta(k,d))));
        y(k,:,mx(k))=sss*sc;
   end
end
sumc1=0;sumC1=0; 
for k=1:a 
   YR=zeros(1,mx(k));yr=zeros(1,4,mx(k)); 
   YR(1,:)=squeeze(Y(k,1:mx(k)));YRS=squeeze(YR(1,:));
   yr(1,:,:)=squeeze(y(k,:,1:mx(k)));yrs=squeeze(yr(1,:,:));
   yrYR=yrs*YRS';yryr=yrs*transpose(yrs);YRSYRS=YRS*YRS';
% Switching ridge regression start by updating the diagonal elements of the 
% ridge matrix used to overcome collinarity
   for i=1:4
        %kk(i,i)=gamrnd((A+mx(k)),(B+(bta(k,i))^2));
        kj(i,i)=4*(A+mx(k))/(B+bta(k,i)^2);
        %kj(i,i)=5/(sum(bta(k,:).^2));
   end
  BB0=yryr/sig(1,d)+kj/sig(1,d);
  b0k=squeeze(b0(k,:));bb0k=kj*b0k';
  B1=inv(BB0);
   bb=((sig(1,d)*BB0)\(yrYR+bb0k)); 
   %bb=BB0\(yrYR+bb0k);
   bta(k,:)=mvnrnd(bb,B1);
   alp0(k,d+1)=bta(k,1);alp1(k,d+1)=bta(k,2);alp2(k,d+1)=bta(k,3);alp3(k,d+1)=bta(k,4);
   btas=squeeze(bta(k,:));
   %Simulation of sigma from inverse gamma 
   sumC1=sumC1+YRSYRS/2+b0k*(BB0\b0k')/2-bb'*(BB0\bb)/2;
   sumc1=sumc1+mx(k,1)/2;    
end
sumc1=sumc1+A;
sumC1=sumC1+B;
sig(1,d+1)=(sumC1/chi2rnd(sumc1))/12;
%Simulation of eta by metropolis hasting algorithm
etaold=squeeze(eta(:,d));etanew=zeros(a,1);
for k=1:a
    logeta=normrnd(log(mean2(eta(k,1:d))),0.03);    
    etanew(k,1)=exp(logeta);
    priornew=gampdf(etanew(k,1),0.01,0.01);
    priorold=gampdf(etaold(k,1),0.01,0.01);
    nom=1;den=1;
    for i=1:n 
      for j=2:N(i)
         if sdd(i,j-1,d+1)==k 
          nom=nom*normpdf((xxd(i,j,d+1)),xxd(i,j-1,d+1)+(alp0(k,d+1)+(alp1(k,d+1)*...
          xxd(i,j-1,d+1))+(alp2(k,d+1)*((xxd(i,j-1,d+1))^2))+alp3(k,d+1)/xxd(i,j-1,d+1))...
          *(td1(i,j)-td1(i,j-1)),sig(1,d+1)*((xxd(i,j-1,d+1))^(2*etanew(k,1)))*...
          (td1(i,j)-td1(i,j-1)));
          den=den*normpdf(xxd(i,j,d+1),xxd(i,j-1,d+1)+(alp0(k,d+1)+(alp1(k,d+1)*...
          xxd(i,j-1,d+1))+(alp2(k,d+1)*(xxd(i,j-1,d+1))^2)+(alp3(k,d+1)/xxd(i,j-1,d+1)))...
          *(td1(i,j)-td1(i,j-1)),sig(1,d+1)*((xxd(i,j-1,d+1)^(2*etaold(k,1))))*...
          (td1(i,j)-td1(i,j-1)));
         end
      end
    end
    nom=nom*priornew*etanew(k,1);den=den*priorold*etaold(k,1);
    mh=min(1,nom/den);u=rand();
    if u<mh
       eta(k,d+1)=etanew(k,1);
    else
        eta(k,d+1)=eta(k,d);
    end
end 
end

%Example how to compute the posterior mean of some quatities
gma12=squeeze(gma(1,2,1:d));gma13=squeeze(gma(1,3,1:d));
gma21=squeeze(gma(2,1,1:d));gma23=squeeze(gma(2,3,1:d));
gma31=squeeze(gma(3,1,1:d));gma32=squeeze(gma(3,2,1:d));
lmda12=squeeze(lmda(1,2,1:d));lmda13=squeeze(lmda(1,3,1:d));
lmda21=squeeze(lmda(2,1,1:d));lmda23=squeeze(lmda(2,3,1:d));
lmda31=squeeze(lmda(3,1,1:d));lmda32=squeeze(lmda(3,2,1:d));
mgma12=mean(gma12);mgma13=mean(gma13);mgma21=mean(gma21);
mgma23=mean(gma23);
mgma31=mean(gma31);mgma32=mean(gma32);
mlmda12=mean(lmda12);mlmda13=mean(lmda13);
mlmda21=mean(lmda21);mlmda23=mean(lmda23);
mlmda31=mean(lmda31);mlmda32=mean(lmda32);
msig=mean(sig(1,1:d));
alp01=mean(alp0(1,1:d));
alp02=mean(alp0(2,1:d));alp03=mean(alp0(3,1:d));
alp11=mean(alp1(1,1:d));alp12=mean(alp1(2,1:d));
alp13=mean(alp1(3,1:d));
alp21=mean(alp2(1,1:d));alp22=mean(alp2(2,1:d));
alp23=mean(alp2(3,1:d));
alp31=mean(alp3(1,1:d));alp32=mean(alp3(2,1:d));
alp33=mean(alp3(3,1:d));

save hsdsimulation;




